#line 1 "F:/MikroC/fader/fader.c"
#line 1 "f:/mikroc/fader/fader.h"
#line 1 "f:/mikroc/fader/types.h"
#line 14 "f:/mikroc/fader/types.h"
 typedef unsigned long ulong;


 typedef unsigned int uint;


 typedef unsigned short ushort;


 typedef unsigned char byte;


 typedef enum ebool { FALSE, TRUE } boolean;
#line 20 "f:/mikroc/fader/fader.h"
 typedef enum {
 FADE_IN = 0,
 FADE_OUT
 } eFadeDirections;

 typedef enum {
 SINGLE_FADER = 0,
 MULTIPLE_FADERS
 } eFadeMode;

 typedef struct _faderNode {
 unsigned uBounce : 1;
 unsigned uDir : 1;
 unsigned uEnable : 1;
 unsigned uLoop : 1;
 unsigned uMode : 1;
 unsigned uState : 1;
 ushort* pPort;
 byte bytPin;
 byte bytBounces;
 byte bytDelta;
 uint uintCount;
 uint uintDutyTime;
 int intOffTime;
 uint uintRepeats;
 uint uintRptCtr;

 struct _faderNode* pNext;
 } faderDef;


 boolean initFader(faderDef* pF,
 ushort* pPort,
 eFadeMode eMode,
 byte bytPin,
 eFadeDirections eDir,
 boolean blnLoop,
 boolean blnBounce,
 boolean blnEnable,
 byte bytDelta,
 uint uintRepeats);
 void serviceFaders(void);
#line 17 "F:/MikroC/fader/fader.c"
static faderDef* pFLL =  ((void*)0) ;
#line 36 "F:/MikroC/fader/fader.c"
boolean initFader(faderDef* pF,
 ushort* pPort,
 eFadeMode eMode,
 byte bytPin,
 eFadeDirections eDir,
 boolean blnLoop,
 boolean blnBounce,
 boolean blnEnable,
 byte bytDelta,
 uint uintRepeats) {

 if ( !(pF
 && pPort
 && ((eMode == SINGLE_FADER && bytPin < 8)
 || (eMode == MULTIPLE_FADERS))) ) {

 return FALSE;
 }

 if ( bytDelta == 0 ) {
 bytDelta = 1;
 }

 memset(pF, 0, sizeof(faderDef));

 pF->uBounce = (blnBounce == TRUE) ? 1 : 0;
 pF->uDir = (eDir == FADE_OUT) ? 1 : 0;
 pF->uEnable = (blnEnable == TRUE) ? 1 : 0;
 pF->uLoop = (blnLoop == TRUE) ? 1 : 0;
 pF->uMode = (eMode == MULTIPLE_FADERS) ? 1 : 0;
 pF->pPort = pPort;
 pF->bytPin = bytPin;
 pF->bytDelta = bytDelta;
 pF->uintRepeats = uintRepeats;

 if ( pF->uDir == FADE_IN ) {
 pF->uintDutyTime = 1;
 pF->intOffTime =  100 ;
 } else {
 pF->uintDutyTime =  100 ;
 pF->intOffTime = 1;
 }

 if ( pFLL ==  ((void*)0)  ) {
 pFLL = pF;
 } else {

 faderDef* pTail;
 for( pTail=pFLL; pTail->pNext!= ((void*)0) ; pTail=pTail->pNext ) {
 }
 pTail->pNext = pF;
 }
 return TRUE;
}
#line 93 "F:/MikroC/fader/fader.c"
void serviceFaders(void) {
 faderDef* pF;
 for( pF=pFLL; pF!= ((void*)0) ; pF=pF->pNext ) {
 if ( pF->uEnable == 0 ) {

 continue;
 }
 if ( pF->uintCount-- == 0 ) {
 if ( pF->uState == 1 && pF->intOffTime > 0 ) {
 pF->uintCount = (uint)pF->intOffTime;
 pF->uState = 0;
 } else {
 pF->uintCount = pF->uintDutyTime;
 pF->uState = 1;
 }
 if ( pF->uintRptCtr++ >= pF->uintRepeats ) {
 if ( pF->uDir == FADE_IN && pF->intOffTime > 0 ) {
 if ( pF->intOffTime - (int)pF->bytDelta > 0 ) {
 pF->intOffTime = pF->intOffTime - (int)pF->bytDelta;
 } else {
 pF->intOffTime = 0;
 }
 } else if ( pF->uDir == FADE_OUT && pF->intOffTime <=  100  ) {
 if ( pF->intOffTime + (int)pF->bytDelta >  100  ) {
 pF->intOffTime =  100 ;
 } else {
 pF->intOffTime = pF->intOffTime + (int)pF->bytDelta;
 }
 }
 pF->uintDutyTime =  100  - pF->intOffTime;
 pF->uintRptCtr = 0;

 if ( pF->uDir == FADE_IN && pF->intOffTime == 0 ) {
 if ( pF->uLoop ) {
 pF->uintDutyTime = 1;
 pF->intOffTime =  100 ;
 pF->uintCount = pF->uintDutyTime;
 }
 if ( pF->uBounce ) {
 pF->uDir = FADE_OUT;
 pF->uintDutyTime =  100 ;
 pF->uintCount = pF->uintDutyTime;
 pF->intOffTime = 1;
 pF->bytBounces++;
 }
 if ( !pF->uLoop && (!pF->uBounce
 || (pF->uBounce && pF->bytBounces > 1)) ) {
 pF->uEnable = 0;
 } else {
 pF->uEnable = 1;
 }
 pF->uState = 1;
 } else if ( pF->uDir == FADE_OUT && pF->uintDutyTime == 0 ) {
 if ( pF->uLoop ) {
 pF->uintDutyTime =  100 ;
 pF->uintCount = pF->uintDutyTime;
 pF->intOffTime = 1;
 }
 if ( pF->uBounce ) {
 pF->uDir = FADE_IN;
 pF->uintDutyTime = 1;
 pF->intOffTime =  100 ;
 pF->uintCount = pF->uintDutyTime;
 pF->bytBounces++;
 }
 if ( !pF->uLoop && (!pF->uBounce
 || (pF->uBounce && pF->bytBounces > 1)) ) {
 pF->uEnable = 0;
 } else {
 pF->uEnable = 1;
 }
 pF->uState = 0;
 }
 }
 }
 if ( pF->uState ) {

 if ( pF->uMode == MULTIPLE_FADERS ) {
 *pF->pPort |= pF->bytPin;
 } else {
 *pF->pPort |= (1 << pF->bytPin);
 }
 } else {

 if ( pF->uMode == MULTIPLE_FADERS ) {
 *pF->pPort &= 0xff ^ pF->bytPin;
 } else {
 *pF->pPort &= 0xff ^ (1 << pF->bytPin);
 }
 }
 }
}
