
_interrupt:

;main.c,31 :: 		void interrupt() {
;main.c,32 :: 		if ( TMR0IF_bit ) {
	BTFSS       TMR0IF_bit+0, 2 
	GOTO        L_interrupt0
;main.c,33 :: 		serviceFaders();
	CALL        _serviceFaders+0, 0
;main.c,34 :: 		TMR0H = 0xFF;    // preset for Timer0 MSB register
	MOVLW       255
	MOVWF       TMR0H+0 
;main.c,35 :: 		TMR0L = 0x38;    // preset for Timer0 LSB register
	MOVLW       56
	MOVWF       TMR0L+0 
;main.c,36 :: 		TMR0IF_bit = 0;
	BCF         TMR0IF_bit+0, 2 
;main.c,37 :: 		}
L_interrupt0:
;main.c,38 :: 		}
L_end_interrupt:
L__interrupt4:
	RETFIE      1
; end of _interrupt

_main:

;main.c,42 :: 		void main() {
;main.c,43 :: 		ANSELB = 0;                    // Configure PORTB pins as digital
	CLRF        ANSELB+0 
;main.c,44 :: 		ANSELC = 0;                    // Configure PORTC pins as digital
	CLRF        ANSELC+0 
;main.c,45 :: 		ANSELD = 0;                    // Configure PORTD pins as digital
	CLRF        ANSELD+0 
;main.c,46 :: 		ANSELE = 0;                    // Configure PORTD pins as digital
	CLRF        ANSELE+0 
;main.c,47 :: 		TRISB = 0;                     // Configure PORTB as output
	CLRF        TRISB+0 
;main.c,48 :: 		TRISC = 0;                     // Configure PORTC as output
	CLRF        TRISC+0 
;main.c,49 :: 		TRISD = 0;                     // Configure PORTD as output
	CLRF        TRISD+0 
;main.c,50 :: 		TRISE = 0x0f;                  // Configure PORTE as input
	MOVLW       15
	MOVWF       TRISE+0 
;main.c,51 :: 		LATB = 0;                      // Clear PORTC
	CLRF        LATB+0 
;main.c,52 :: 		LATC = 0;                      // Clear PORTC
	CLRF        LATC+0 
;main.c,53 :: 		LATD = 0;                      // Clear PORTD
	CLRF        LATD+0 
;main.c,55 :: 		initFader(&aryFaders[0], &LATC, MULTIPLE_FADERS, 0x55, FADE_IN, TRUE, TRUE, TRUE,
	MOVLW       main_aryFaders+0
	MOVWF       FARG_initFader_pF+0 
	MOVLW       hi_addr(main_aryFaders+0)
	MOVWF       FARG_initFader_pF+1 
	MOVLW       LATC+0
	MOVWF       FARG_initFader_pPort+0 
	MOVLW       hi_addr(LATC+0)
	MOVWF       FARG_initFader_pPort+1 
	MOVLW       1
	MOVWF       FARG_initFader_eMode+0 
	MOVLW       85
	MOVWF       FARG_initFader_bytPin+0 
	CLRF        FARG_initFader_eDir+0 
	MOVLW       1
	MOVWF       FARG_initFader_blnLoop+0 
	MOVLW       1
	MOVWF       FARG_initFader_blnBounce+0 
	MOVLW       1
	MOVWF       FARG_initFader_blnEnable+0 
;main.c,56 :: 		3, NUMBER_OF_REPEATS);
	MOVLW       3
	MOVWF       FARG_initFader_bytDelta+0 
	CLRF        FARG_initFader_uintRepeats+0 
	CLRF        FARG_initFader_uintRepeats+1 
	CALL        _initFader+0, 0
;main.c,57 :: 		initFader(&aryFaders[1], &LATD, MULTIPLE_FADERS, 0xaa, FADE_IN, TRUE, TRUE, TRUE,
	MOVLW       main_aryFaders+18
	MOVWF       FARG_initFader_pF+0 
	MOVLW       hi_addr(main_aryFaders+18)
	MOVWF       FARG_initFader_pF+1 
	MOVLW       LATD+0
	MOVWF       FARG_initFader_pPort+0 
	MOVLW       hi_addr(LATD+0)
	MOVWF       FARG_initFader_pPort+1 
	MOVLW       1
	MOVWF       FARG_initFader_eMode+0 
	MOVLW       170
	MOVWF       FARG_initFader_bytPin+0 
	CLRF        FARG_initFader_eDir+0 
	MOVLW       1
	MOVWF       FARG_initFader_blnLoop+0 
	MOVLW       1
	MOVWF       FARG_initFader_blnBounce+0 
	MOVLW       1
	MOVWF       FARG_initFader_blnEnable+0 
;main.c,58 :: 		5, NUMBER_OF_REPEATS);
	MOVLW       5
	MOVWF       FARG_initFader_bytDelta+0 
	CLRF        FARG_initFader_uintRepeats+0 
	CLRF        FARG_initFader_uintRepeats+1 
	CALL        _initFader+0, 0
;main.c,65 :: 		T0CON.TMR0ON = 1;// Timer0 On/Off Control bit:1=Enables Timer0 / 0=Stops Timer0
	BSF         T0CON+0, 7 
;main.c,66 :: 		T0CON.T08BIT = 0;// Timer0 8-bit/16-bit Control bit: 1=8-bit timer/counter / 0=16-bit timer/counter
	BCF         T0CON+0, 6 
;main.c,67 :: 		T0CON.T0CS   = 0;// TMR0 Clock Source Select bit: 0=Internal Clock (CLKO) / 1=Transition on T0CKI pin
	BCF         T0CON+0, 5 
;main.c,68 :: 		T0CON.T0SE   = 0;// TMR0 Source Edge Select bit: 0=low/high / 1=high/low
	BCF         T0CON+0, 4 
;main.c,69 :: 		T0CON.PSA    = 1;// Prescaler Assignment bit: 0=Prescaler is assigned; 1=NOT assigned/bypassed
	BSF         T0CON+0, 3 
;main.c,70 :: 		T0CON.T0PS2  = 0;// bits 2-0  PS2:PS0: Prescaler Select bits
	BCF         T0CON+0, 2 
;main.c,71 :: 		T0CON.T0PS1  = 0;
	BCF         T0CON+0, 1 
;main.c,72 :: 		T0CON.T0PS0  = 0;
	BCF         T0CON+0, 0 
;main.c,73 :: 		TMR0H = 0xFF;    // preset for Timer0 MSB register
	MOVLW       255
	MOVWF       TMR0H+0 
;main.c,74 :: 		TMR0L = 0x38;    // preset for Timer0 LSB register
	MOVLW       56
	MOVWF       TMR0L+0 
;main.c,75 :: 		TMR0IE_bit = 1;
	BSF         TMR0IE_bit+0, 5 
;main.c,77 :: 		GIE_bit = 1;
	BSF         GIE_bit+0, 7 
;main.c,79 :: 		while (1) {
L_main1:
;main.c,80 :: 		}
	GOTO        L_main1
;main.c,81 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
